'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends4 = require('babel-runtime/helpers/extends');

var _extends5 = _interopRequireDefault(_extends4);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _taggedTemplateLiteral2 = require('babel-runtime/helpers/taggedTemplateLiteral');

var _taggedTemplateLiteral3 = _interopRequireDefault(_taggedTemplateLiteral2);

var _templateObject = (0, _taggedTemplateLiteral3.default)(['\n  @media print {\n    font-size: 0.6em;\n    line-height: 0.6em;\n  }\n'], ['\n  @media print {\n    font-size: 0.6em;\n    line-height: 0.6em;\n  }\n']),
    _templateObject2 = (0, _taggedTemplateLiteral3.default)(['\n  @media print {\n    font-size: 1em;\n    line-height: 1em;\n    margin-bottom: 0em;\n    margin-top: 0.1em;\n  }\n  margin-top: 0.5em;\n'], ['\n  @media print {\n    font-size: 1em;\n    line-height: 1em;\n    margin-bottom: 0em;\n    margin-top: 0.1em;\n  }\n  margin-top: 0.5em;\n']),
    _templateObject3 = (0, _taggedTemplateLiteral3.default)(['\n    competition(competitionSlug: ', ', yearID: ', ') {\n      isAdministratedByUser\n      payments {\n        id\n        paidByUserEmail\n        expectedForClub\n        paymentStatusRef\n        paymentStatusDescription\n        errorNotifiedDate\n        createdDate\n\n        refunds {\n          id\n          refundedByClub\n          refundDate\n          refundedByUserEmail\n          refundStatusRef\n          refundStatusDescription\n          errorMessage\n        }\n\n        entries {\n          id\n          bibNumber\n          bibName\n          clubName\n          entryReceivedDate\n          ageCategoryDescription\n          classDescription\n          competitionDivision {\n            description\n          }\n          race {\n            competitionDay {\n              date\n            }\n          }\n        }\n      }\n    }\n  '], ['\n    competition(competitionSlug: ', ', yearID: ', ') {\n      isAdministratedByUser\n      payments {\n        id\n        paidByUserEmail\n        expectedForClub\n        paymentStatusRef\n        paymentStatusDescription\n        errorNotifiedDate\n        createdDate\n\n        refunds {\n          id\n          refundedByClub\n          refundDate\n          refundedByUserEmail\n          refundStatusRef\n          refundStatusDescription\n          errorMessage\n        }\n\n        entries {\n          id\n          bibNumber\n          bibName\n          clubName\n          entryReceivedDate\n          ageCategoryDescription\n          classDescription\n          competitionDivision {\n            description\n          }\n          race {\n            competitionDay {\n              date\n            }\n          }\n        }\n      }\n    }\n  ']);

var _ms = require('ms');

var _ms2 = _interopRequireDefault(_ms);

var _occasion = require('occasion');

var _occasion2 = _interopRequireDefault(_occasion);

var _table = require('core/table');

var _table2 = _interopRequireDefault(_table);

var _gbp = require('gbp');

var _gbp2 = _interopRequireDefault(_gbp);

var _button = require('core/button');

var _button2 = _interopRequireDefault(_button);

var _helpButton = require('core/help-button');

var _helpButton2 = _interopRequireDefault(_helpButton);

var _paymentEntries = require('./payment-entries');

var _paymentEntries2 = _interopRequireDefault(_paymentEntries);

var _paymentsHelp = require('./payments-help');

var _paymentsHelp2 = _interopRequireDefault(_paymentsHelp);

var _refunds = require('./refunds');

var _refunds2 = _interopRequireDefault(_refunds);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _pugFlattenInnerHelper(arr, val) {
  return arr.concat(Array.isArray(val) ? _pugFlatten(val) : val);
}

function _pugFlatten(arr) {
  return arr.reduce(_pugFlattenInnerHelper, []);
}

var styled = {};
var Component = {};
var React = {};
var connect = {};
var bql = {};

// the styled components are purely to improve the layout of the printed version of the start list
// Tr shrinks all the table rows. Tbody should stop breaks within each group but does not always do so
// successfully (depends on browser).
var Tr = styled.tr(_templateObject);
var H2 = styled.h2(_templateObject2);

var Payments = function (_Component) {
  (0, _inherits3.default)(Payments, _Component);

  function Payments() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, Payments);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = Payments.__proto__ || (0, _getPrototypeOf2.default)(Payments)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      showEntries: [],
      showRefunds: []
    }, _this._displayDateTime = function (value) {
      if (!value) return '';
      var datePart = value.split('T')[0];
      var timePart = value.split('T')[1].split('.')[0];
      return (0, _occasion2.default)(datePart, 'D MMM') + " " + timePart.substring(0, 5);
    }, _this._msSince = function (thisdatetime) {
      var msSince = 0;
      if (thisdatetime) {
        msSince = new Date(thisdatetime).getTime();
        msSince = Math.max(Date.now() - msSince, 0);
      }
      return msSince;
    }, _this._toggleShowEntries = function (paymentID) {
      _this.setState({
        showEntries: (0, _extends5.default)({}, _this.state.showEntries, (0, _defineProperty3.default)({}, paymentID, !_this.state.showEntries[paymentID]))
      });
    }, _this._toggleShowRefunds = function (paymentID) {
      _this.setState({
        showRefunds: (0, _extends5.default)({}, _this.state.showRefunds, (0, _defineProperty3.default)({}, paymentID, !_this.state.showRefunds[paymentID]))
      });
    }, _this._onRequestRefund = function (id) {
      console.dir("refund request");
    }, _this._getStatusClass = function (paymentStatusRef) {
      if (paymentStatusRef === 'PAID') return 'text-xs-right text-success';
      if (paymentStatusRef === 'ERR') return 'text-xs-right text-danger';
      return 'text-xs-right';
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  // TODO times are stored as UTC but we probably need to consider BST
  // Also not that confident of this function.  Function also in EntriesTableRow


  (0, _createClass3.default)(Payments, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var competition = this.props.competition;

      // Calculate total payments and refunds
      var totalExpectedForClub = 0;
      var totalRefundedByClub = 0;
      var numberOfRefunds = 0;

      if (this.props.loaded) {
        var numberOfPayments = (0, _keys2.default)(competition.payments).length;
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = (0, _getIterator3.default)(competition.payments), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var payment = _step.value;

            totalExpectedForClub += payment.expectedForClub;
            numberOfRefunds += (0, _keys2.default)(payment.refunds).length;
            var _iteratorNormalCompletion2 = true;
            var _didIteratorError2 = false;
            var _iteratorError2 = undefined;

            try {
              for (var _iterator2 = (0, _getIterator3.default)(payment.refunds), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                var refund = _step2.value;

                totalRefundedByClub += refund.refundedByClub;
              }
            } catch (err) {
              _didIteratorError2 = true;
              _iteratorError2 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion2 && _iterator2.return) {
                  _iterator2.return();
                }
              } finally {
                if (_didIteratorError2) {
                  throw _iteratorError2;
                }
              }
            }
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }
      }

      return React.createElement(
        'div',
        null,
        React.createElement(
          H2,
          null,
          'On-Line Payments and Refunds'
        ),
        React.createElement(
          _helpButton2.default,
          null,
          React.createElement(_paymentsHelp2.default, null)
        ),
        competition.isAdministratedByUser ? React.createElement(
          _table2.default,
          {
            key: 'pug:0:0'
          },
          React.createElement(
            'thead',
            null,
            React.createElement(
              Tr,
              null,
              React.createElement('th', {
                className: 'hidden-print'
              }),
              React.createElement('th', {
                className: 'hidden-print'
              }),
              React.createElement(
                'th',
                null,
                'Date'
              ),
              React.createElement(
                'th',
                {
                  className: 'hidden-print'
                },
                'Contact Email'
              ),
              React.createElement(
                'th',
                {
                  className: 'text-xs-right'
                },
                'Paid To Club'
              ),
              React.createElement('th', null)
            )
          ),
          React.createElement(
            'tbody',
            null,
            function () {
              var pug_nodes = [];
              var _pug_arr = competition.payments;

              if (Array.isArray(_pug_arr)) {
                for (var _pug_index2 = 0; _pug_index2 < _pug_arr.length; _pug_index2++) {
                  var _payment = _pug_arr[_pug_index2];
                  pug_nodes.push(React.createElement(
                    Tr,
                    {
                      className: [_this2._msSince(_payment.errorNotifiedDate) > (0, _ms2.default)('48h') && _payment.paymentStatusRef === 'ERR' ? 'table-danger' : ''].join(' '),
                      key: 'pug:' + _payment.id + ':0'
                    },
                    React.createElement(
                      'td',
                      {
                        className: 'hidden-print'
                      },
                      React.createElement(
                        _button2.default,
                        {
                          size: "sm",
                          onClick: _this2._toggleShowEntries.bind(_this2, _payment.id)
                        },
                        _this2.state.showEntries[_payment.id] ? 'Hide Entries' : 'Show Entries'
                      )
                    ),
                    React.createElement(
                      'td',
                      {
                        className: 'hidden-print'
                      },
                      _payment.refunds.length ? React.createElement(
                        _button2.default,
                        {
                          size: "sm",
                          onClick: _this2._toggleShowRefunds.bind(_this2, _payment.id),
                          key: 'pug:1:0'
                        },
                        _this2.state.showRefunds[_payment.id] ? 'Hide Refunds' : 'Show Refunds'
                      ) : null
                    ),
                    React.createElement(
                      'td',
                      null,
                      _this2._displayDateTime(_payment.createdDate)
                    ),
                    React.createElement(
                      'td',
                      {
                        className: 'hidden-print'
                      },
                      _payment.paidByUserEmail
                    ),
                    React.createElement(
                      'td',
                      {
                        className: 'text-xs-right'
                      },
                      (0, _gbp2.default)(_payment.expectedForClub)
                    ),
                    React.createElement(
                      'td',
                      {
                        className: [_this2._getStatusClass(_payment.paymentStatusRef)].join(' ')
                      },
                      _payment.paymentStatusDescription,
                      _payment.paymentStatusRef === 'ERR' ? [_payment.errorNotifiedDate ? '- user notified ' : '', _payment.errorNotifiedDate ? (0, _ms2.default)(_this2._msSince(_payment.errorNotifiedDate), { long: true }) : '', _payment.errorNotifiedDate ? ' ago.' : ''] : null
                    )
                  ));

                  if (_this2.state.showEntries[_payment.id]) {
                    pug_nodes.push(React.createElement(
                      Tr,
                      {
                        key: 'pug:' + _payment.id + ':1:3:0'
                      },
                      React.createElement('td', null),
                      React.createElement(
                        'td',
                        {
                          colSpan: 5
                        },
                        React.createElement(_paymentEntries2.default, {
                          showEntries: _this2.state.showEntries[_payment.id],
                          entries: _payment.entries,
                          displayDateTime: _this2._displayDateTime
                        })
                      )
                    ));
                  }

                  if (_this2.state.showRefunds[_payment.id]) {
                    pug_nodes.push(React.createElement(
                      Tr,
                      {
                        key: 'pug:' + _payment.id + ':2:4:0'
                      },
                      React.createElement('td', null),
                      React.createElement(
                        'td',
                        {
                          colSpan: 5
                        },
                        React.createElement(_refunds2.default, {
                          refunds: _payment.refunds,
                          displayDateTime: _this2._displayDateTime
                        })
                      )
                    ));
                  }
                }
              } else {
                throw new TypeError('Expected competition.payments to be an array.');
              }

              return pug_nodes;
            }()
          ),
          React.createElement(
            'tfoot',
            {
              className: 'hidden-print'
            },
            React.createElement(
              'tr',
              null,
              React.createElement(
                'th',
                {
                  colSpan: "4",
                  className: 'text-xs-right'
                },
                numberOfPayments + " Payments Totalling"
              ),
              React.createElement(
                'th',
                {
                  className: 'text-xs-right'
                },
                (0, _gbp2.default)(totalExpectedForClub)
              )
            ),
            numberOfRefunds ? [React.createElement(
              'tr',
              {
                key: 'pug:5:0'
              },
              React.createElement(
                'th',
                {
                  colSpan: "4",
                  className: 'text-xs-right'
                },
                numberOfRefunds + " Refunds Totalling"
              ),
              React.createElement(
                'th',
                {
                  className: 'text-xs-right'
                },
                (0, _gbp2.default)(totalRefundedByClub)
              )
            ), React.createElement(
              'tr',
              {
                key: 'pug:5:1'
              },
              React.createElement(
                'th',
                {
                  colSpan: "4",
                  className: 'text-xs-right'
                },
                'BALANCE'
              ),
              React.createElement(
                'th',
                {
                  className: 'text-xs-right'
                },
                (0, _gbp2.default)(totalExpectedForClub - totalRefundedByClub)
              )
            )] : null
          )
        ) : null
      );
    }
  }]);
  return Payments;
}(Component);

// *******************************************************************************
// Data and actions
// *******************************************************************************

exports.default = connect(function (props) {
  return bql(_templateObject3, props.params.competitionSlug, +props.params.yearID);
})(Payments);