'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (babel) {
  var t = babel.types;

  (0, _babelTypes.setBabelTypes)(t);
  function isReactPugReference(node) {
    // TODO: do this better
    return t.isIdentifier(node, { name: 'pug' });
  }
  return {
    visitor: {
      TaggedTemplateExpression: function TaggedTemplateExpression(path) {
        if (isReactPugReference(path.node.tag) && path.node.quasi.expressions.length === 0 && path.node.quasi.quasis.length === 1) {
          var src = path.node.quasi.quasis[0].value.raw;
          var minIndent = src.split('\n').reduce(function (minIndent, line) {
            return line.trim().length ? Math.min(/^ */.exec(line)[0].length, minIndent) : minIndent;
          }, Infinity);
          src = src.split('\n').map(function (line) {
            return line.substr(minIndent);
          }).join('\n');
          var ast = (0, _parsePug2.default)(src);

          var context = _context2.default.create(this.file, path);
          var transformed = ast.nodes.map(function (node) {
            return (0, _visitors.visitExpression)(node, context);
          });
          var expression = transformed.length === 1 ? transformed[0] : t.arrayExpression(transformed);
          if (context.variablesToDeclare.length) {}
          context.variablesToDeclare.forEach(function (id) {
            path.scope.push({ kind: 'let', id: id });
          });
          path.replaceWith(expression);
        }
      }
    }
  };
};

var _babylon = require('babylon');

var _parsePug = require('./parse-pug');

var _parsePug2 = _interopRequireDefault(_parsePug);

var _context = require('./context');

var _context2 = _interopRequireDefault(_context);

var _visitors = require('./visitors');

var _babelTypes = require('./babel-types');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }