'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = parseExpression;

var _parse = require('./parse');

var _parse2 = _interopRequireDefault(_parse);

var _addLocToAst = require('./add-loc-to-ast');

var _addLocToAst2 = _interopRequireDefault(_addLocToAst);

var _babelTypes = require('../babel-types');

var _babelTypes2 = _interopRequireDefault(_babelTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function parseExpression(src, context) {
  var val = (0, _parse2.default)('x = (' + src + ');', context);
  if (val.length !== 1) {
    var err = context.error('INVALID_EXPRESSION', 'There was an error parsing the expression "' + src + '".');
    throw err;
  }
  var expressionStatement = _babelTypes2.default.asExpressionStatement(val[0]);
  var assignmentExpression = expressionStatement && _babelTypes2.default.asAssignmentExpression(expressionStatement.expression);
  if (!assignmentExpression) {
    var _err = context.error('INVALID_EXPRESSION', 'There was an error parsing the expression "' + src + '".');
    throw _err;
  }
  (0, _addLocToAst2.default)(assignmentExpression);
  return assignmentExpression.right;
}