'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.visitExpression = visitExpression;
exports.visitJsx = visitJsx;

var _babelTypes = require('./babel-types');

var _babelTypes2 = _interopRequireDefault(_babelTypes);

var _visitorsGenerated = require('./visitors.generated.js');

var _visitorsGenerated2 = _interopRequireDefault(_visitorsGenerated);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function visitExpression(node, context) {
  var line = node.line + context.getBaseLine();
  (0, _babelTypes.setCurrentLocation)({ start: { line: line, column: 0 }, end: { line: line, column: 0 } });
  var v = _visitorsGenerated2.default[node.type];
  if (!v) {
    throw new Error(node.type + ' is not yet supported');
  }
  return v.expression(node, context);
}

function visitJsx(node, context) {
  var line = node.line + context.getBaseLine();
  (0, _babelTypes.setCurrentLocation)({ start: { line: line, column: 0 }, end: { line: line, column: 0 } });
  var v = _visitorsGenerated2.default[node.type];
  if (!v) {
    throw new Error(node.type + ' is not yet supported');
  }
  return v.jsx ? v.jsx(node, context) : _babelTypes2.default.jSXExpressionContainer(v.expression(node, context));
}